/* this is not finished and does not work well, I misunderstand something somewhere */

/* define MAIN for testing, then compile as:
 * gcc -o reed_solomon coding/reed_solomon.c
 */
//#define MAIN

/* fire code: decoding algorithm taken from the book
 * Error control coding : fundamentals and applications
 * by Costello, Daniel J.; Lin, Shu,
 * 2nd edition, 2004
 * may be downloaded from https://annas-archive.org/ (link valid 2025-03-29)
 */

#include "firecode.h"

#include <stdio.h>
#include <stdlib.h>

#ifndef MAIN
#include "utils/log.h"
#else
#define debug printf
#define error printf
#endif

static int shift(int poly, int n, int r, int b)
{
  int last = (r >> (n-1)) & 1;
  r = ((r << 1) | b);
  if (last) r ^= poly;
  return r & ((1 << n) - 1);
}

static int crc(unsigned char *data, int len, int poly, int crcsize, int init_value,
               int do_complement)
{
  int i;
  int j;
  int shift = init_value;
  int ret;

  poly >>= 1;

  for (i = 0; i < len; i++) {
    unsigned char d = data[i];
    for (j = 0; j < 8; j++, d<<=1) {
      int b = ((d >> 7) ^ (shift >> (crcsize-1))) & 1;
      shift = ((shift ^ (-b & poly)) << 1) | b;
    }
  }

  ret = shift & ((1 << crcsize) - 1);
  if (do_complement)
    ret = ~ret & ((1 << crcsize) - 1);

  return ret;
}

/* find a1, a2, such that a1 * (2 * l - 1) + a2 * rho = 1 */
static void get_a1_a2(int *a1, int *a2, int l, int rho)
{
  int a = 2 * l - 1;
  int b = rho;
  int x0;
  int y0;

  for (x0 = 1; x0 < b; x0++)
    if ((a * x0) % b == 1) break;
  if (x0 == b) abort();

  y0 = (1 - a * x0) / b;

  *a1 = x0;
  *a2 = y0;
}

void fire_decode(unsigned char *data)
{
  debug("firecode: input");
  for (int i = 0; i <= 10; i++) printf(" %2.2x", data[i]);
  debug("\n");
//data[10] ^= 0x3 << 5;
//data[9] ^= 0x2;
  debug("firecode: crc of fire data %2.2x\n", crc(data + 2, 9, 0x1782f, 16, 0, 0));

  /***************************************************/
  /* error pattern                                   */
  /***************************************************/

  int r = 0;
  int poly = 1 + (1 << 11);
  int n = -1; { int p = poly; while (p) { p >>= 1; n++; } }
  for (int i = 2; i <= 10; i++) {
    for (int bit = 7; bit >= 0; bit--)
      r = shift(poly, n, r, (data[i] >> bit) & 1);
  }
  for (int i = 0; i <= 1; i++) {
    for (int bit = 7; bit >= 0; bit--)
      r = shift(poly, n, r, (data[i] >> bit) & 1);
  }
#if 0
  for (int bit = 11*8; bit < 341; bit++)
    r = shift(poly, n, r, 0);
#endif

  debug("error_pattern_register = %4.4x\n", r);

  int error_pattern_register = r;
  int error_pattern_shift_count = 0;

  int l = (n+1) / 2;
debug("l %d\n", l);
  int error_pattern_mask = ((1 << (l-1)) -1) << l;

  /* hack: ETSI TS 102 563 claims we can correct most single error burst of
   * up to 6 bits. The book "Error control coding : fundamentals and
   * applications" by Costello, Daniel J.; Lin, Shu gives an algorithm in
   * 20.3.1 (figure 20.3) that checks l bits. Problem here: l = 6, but
   * second poly in use here is (x^5+x^3+x^2+x+1) which gives a remainder
   * of 5 bits max, not 6.
   * So let's force error_pattern_mask to be 5 bits. We can correct only
   * errors of 5 bits.
   * (maybe doing this makes the decoder non-working? small tests show
   * it still works...)
   * TODO: find another (efficient) algorithm to correct 6 bits errors.
   */
  error_pattern_mask = ((1 << l) -1) << (l-1);

debug("initial error pattern register %b mask %b\n", error_pattern_register, error_pattern_mask);
  //while (((error_pattern_register & error_pattern_mask) || (error_pattern_register && (error_pattern_register & 1) == 0))
  while ((error_pattern_register & error_pattern_mask)
         /* book says "no more than 2l-2 shifts are needed, let's do +1 (not
          * sure if correct) */
         && error_pattern_shift_count < 2*l-2+1) {
debug("error pattern register before shift %b mask %b\n", error_pattern_register, error_pattern_mask);
    error_pattern_register = shift(poly, n, error_pattern_register, 0);
debug("error pattern register after shift %b\n", error_pattern_register);
    error_pattern_shift_count++;
  }
  if (error_pattern_shift_count == 2*l-2+1) {
    debug("firecode: uncorrectable error (last computed pattern %b)\n", error_pattern_register);
    return;
  }
  debug("firecode: error_pattern_shift_count %d\n", error_pattern_shift_count);
  debug("firecode: error_pattern_register %b\n", error_pattern_register);

  /* rho is the smallest integer such that dividing
   * x^rho+1 by x^5+x^3+x^2+x+1 gives a remainder = 0
   */
  int rho = 31;

  /* codeword length is LCM(11, rho) = 341 (lcm: least common multiple)
   * 11 is from poly of firecode = (x^11+1) * (x^5+x^3+x^2+x+1)
   * rho = 31 as found above by testing rho=1, 2, ... until remainder = 0
   */
  int codeword_length = 341;

  /***************************************************/
  /* error location                                  */
  /***************************************************/

  r = 0;
  poly = 1 + (1 << 1) + (1 << 2) + (1 << 3) + (1 << 5);
  n = -1; { int p = poly; while (p) { p >>= 1; n++; } }
  for (int i = 2; i <= 10; i++) {
    for (int bit = 7; bit >= 0; bit--)
      r = shift(poly, n, r, (data[i] >> bit) & 1);
  }
  for (int i = 0; i <= 1; i++) {
    for (int bit = 7; bit >= 0; bit--)
      r = shift(poly, n, r, (data[i] >> bit) & 1);
  }
#if 0
  for (int bit = 11*8; bit < 341; bit++)
    r = shift(poly, n, r, 0);
#endif

  debug("firecode: error_location_register = %4.4x\n", r);

  int error_location_register = r;
  int error_location_shift_count = 0;

  if (error_pattern_register == 0 && error_location_register == 0) {
    debug("firecode: no error\n");
    return;
  }

  while (error_location_register != error_pattern_register
         //) {
         && error_location_shift_count < rho-1+1) {
    error_location_register = shift(poly, n, error_location_register, 0);
debug("error_location_register %b error_pattern_register %b\n", error_location_register, error_pattern_register);
    error_location_shift_count++;
  }
  if (error_location_shift_count == rho-1+1) {
    debug("firecode: uncorrectable error (can this case happen?)\n");
    return;
  }
  debug("firecode: error_location_shift_count %d\n", error_location_shift_count);
  debug("firecode: error_location_register %d\n", error_location_register);

  int a1, a2;

  /* TODO: we may hardcode a1, a2, for a slight speedup */
  get_a1_a2(&a1, &a2, l, rho);

  int lambda1 = error_pattern_shift_count;
  int lambda2 = error_location_shift_count;

  int q = a1 * (2 * l - 1) * lambda2 + a2 * rho * lambda1;
  debug("pre-q %d\n", q);
  q %= codeword_length;
  debug("q %d n-q %d\n", q, codeword_length - q);

  int start_bit;

  if (q == 0)
    start_bit = q;
  else
    start_bit = codeword_length - q;

  /* correct */
  int current_bit = start_bit;
  while (error_pattern_register) {
    if (error_pattern_register & 1) {
      int byte = current_bit / 8;
      if (byte > 10) {
        error("firecode: fatal error, data corrupted (byte %d start_bit %d)\n", byte, start_bit);
        return;
      }
      int bit = current_bit % 8;
      /* from 'current_bit' we need to find the corresponding bit in 'data',
       * the byte is given by b2b
       * and the bit is the 'bit' one
       */
      int b2b[] = { 1, 0, 10, 9, 8, 7, 6, 5, 4, 3, 2 };
      data[b2b[byte]] ^= 1 << bit;
    }
    error_pattern_register >>= 1;
    current_bit++;
  }
  debug("firecode: after correction: crc of fire data %2.2x [data[0..1] = %2.2x %2.2x]\n", crc(data + 2, 9, 0x1782f, 16, 0, 0), data[0], data[1]);
}

#ifdef MAIN

/* len is in bits, not bytes */
static int crc_bit(unsigned char *data, int len_bit, int poly, int crcsize, int init_value,
                   int do_complement)
{
  int i;
  int j;
  int shift = init_value;
  int ret;
  int len = len_bit / 8;
  int remaining_bits = len_bit % 8;

  poly >>= 1;

  for (i = 0; i < len; i++) {
    unsigned char d = data[i];
    for (j = 0; j < 8; j++, d<<=1) {
      int b = ((d >> 7) ^ (shift >> (crcsize-1))) & 1;
      shift = ((shift ^ (-b & poly)) << 1) | b;
    }
  }
  unsigned char last_byte = data[i];
  for (j = 0; j < remaining_bits; j++, last_byte<<=1) {
    int b = ((last_byte >> 7) ^ (shift >> (crcsize-1))) & 1;
    shift = ((shift ^ (-b & poly)) << 1) | b;
  }

  ret = shift & ((1 << crcsize) - 1);
  if (do_complement)
    ret = ~ret & ((1 << crcsize) - 1);

  return ret;
}

static void test_crc(void)
{
  unsigned char data[] = {
 0xea, 0x4c, 0x70, 0x18, 0x92, 0xfb, 0x80, 0x24, 0x00, 0x00, 0x00
  };
  debug("%2.2x\n", crc(data + 2, 9, 0x1782f, 16, 0, 0));
}

static void test_remainder(void)
{
  int r = 0;
  int poly = 0x0b;
  int n = -1;
  int input = 0x16;
  { int p = poly; while (p) { p >>= 1; n++; } }
  debug("test_remainder n = %d\n", n);
  for (int i = 0; i < 7; i++) {
    r = shift(poly, n, r, input & 1); input >>= 1;
    debug("r %x\n", r);
  }

  debug("-----\n");

  r = 0b001111100;
  poly = 1 + (1 << 9);
  n = -1;
  { int p = poly; while (p) { p >>= 1; n++; } }
  debug("test_remainder n = %d\n", n);
  for (int i = 0; i < 10; i++) {
    r = shift(poly, n, r, 0);
    debug("i %d r %9.9b\n", i+1, r);
  }
  debug("-----\n");

  r = 0x13;
  poly = 1 + (1 << 1) + (1 << 5); //0x25;
  n = -1;
  { int p = poly; while (p) { p >>= 1; n++; } }
  debug("test_remainder n = %d\n", n);
  for (int i = 0; i < 29; i++) {
    r = shift(poly, n, r, 0);
    debug("i %d r %5.5b\n", i+1, r);
  }
}

static void test_remainder2(void)
{
  unsigned char data[] = {
 0xea, 0x4c, 0x70, 0x18, 0x92, 0xfb, 0x80, 0x24, 0x00, 0x00, 0x00,
 0x6f, 0x51, 0x70, 0x18, 0x92, 0xf8, 0x80, 0x10, 0x00, 0xc2, 0x20,
 0x98, 0xa2, 0x70, 0x1d, 0x53, 0x47, 0x80, 0x29, 0x11, 0x10, 0x11,
 0xf6, 0xd9, 0x70, 0x19, 0x93, 0x1c, 0x80, 0x29, 0x12, 0xd4, 0x56,
 0x85, 0x6e, 0x70, 0x19, 0x53, 0x03, 0x80, 0x29, 0x4b, 0xba, 0xa7,
 0xee, 0xb1, 0x70, 0x19, 0xb3, 0x30, 0x80, 0x29, 0x44, 0x40, 0x44,
 0x07, 0x28, 0x70, 0x19, 0xb3, 0x55, 0x80, 0x29, 0xeb, 0x0e, 0x25,
 0xd9, 0xbc, 0x70, 0x19, 0x43, 0x4b, 0x80, 0x29, 0x10, 0xb2, 0xa5,
 0xb6, 0x97, 0x70, 0x1c, 0xe3, 0x31, 0x80, 0x29, 0x20, 0x22, 0x02,
 0x07, 0x72, 0x70, 0x17, 0xd3, 0x10, 0x80, 0x29, 0xa2, 0xfd, 0x00,
 0x7c, 0x45, 0x70, 0x13, 0xb2, 0x65, 0x80, 0x29, 0xb3, 0x85, 0xa9,
 0x6a, 0x62, 0x70, 0x1b, 0xb3, 0x40, 0x80, 0x2a, 0x00, 0x00, 0x24,
 0xbb, 0xb5, 0x70, 0x1b, 0xf3, 0x4a, 0x80, 0x29, 0x02, 0x22, 0x22,
  };

  for (int i = 0; i < sizeof(data); i+=11)
    fire_decode(data + i);
}

/* use fire code (x^9 + 1) * (1 + x^2 + x^5) = 1 + x^2 + x^5 + x^9 + x^11 + x^14
 * n = 279
 * k = 265
 * l = 5
 */
static void fire_decode_book(unsigned char *data)
{
data[2] ^= 0x08;

  debug("crc of fire data %2.2x\n", crc_bit(data + 2, 265, 0x4a25, 14, 0, 0));

  /***************************************************/
  /* error pattern                                   */
  /***************************************************/

  int r = 0;
  int poly = 1 + (1 << 9);
  int n = -1; { int p = poly; while (p) { p >>= 1; n++; } }

  for (int i = 0; i < 265; i++) {
    int byte = 2 + i / 8;
    int bit = 7 - i % 8;
    r = shift(poly, n, r, (data[byte] >> bit) & 1);
  }
  for (int i = 0; i <= 1; i++) {
    for (int bit = i == 0 ? 5 : 7; bit >= 0; bit--)
      r = shift(poly, n, r, (data[i] >> bit) & 1);
  }

  debug("error_pattern_register = %4.4x\n", r);

  int error_pattern_register = r;
  int error_pattern_shift_count = 0;

  int l = (n+1) / 2;
debug("l %d\n", l);
  int error_pattern_mask = ((1 << (l-1)) -1) << l;
debug("initial error pattern register %b mask %b\n", error_pattern_register, error_pattern_mask);
  while ((error_pattern_register & error_pattern_mask)
         && error_pattern_shift_count < 2*l-2+1) {
debug("error pattern register before shift %b mask %b\n", error_pattern_register, error_pattern_mask);
    error_pattern_register = shift(poly, n, error_pattern_register, 0);
debug("error pattern register after shift %b\n", error_pattern_register);
    error_pattern_shift_count++;
  }
  if (error_pattern_shift_count == 2*l-2+1) {
    debug("fatal: this should not happen(?)\n");
    exit(1);
  }
  debug("error_pattern_shift_count %d\n", error_pattern_shift_count);
  debug("error_pattern_register %b\n", error_pattern_register);

  /* rho is the smallest integer such that dividing
   * x^rho+1 by x^5+x^3+x^2+x+1 gives a remainder = 0
   */
  int rho = 31;



  /***************************************************/
  /* error location                                  */
  /***************************************************/

  r = 0;
  poly = 1 + (1 << 2) + (1 << 5);
  n = -1; { int p = poly; while (p) { p >>= 1; n++; } }

  for (int i = 0; i < 265; i++) {
    int byte = 2 + i / 8;
    int bit = 7 - i % 8;
    r = shift(poly, n, r, (data[byte] >> bit) & 1);
  }
  for (int i = 0; i <= 1; i++) {
    for (int bit = i == 0 ? 5 : 7; bit >= 0; bit--)
      r = shift(poly, n, r, (data[i] >> bit) & 1);
  }

  debug("error_location_register = %4.4x\n", r);

  int error_location_register = r;
  int error_location_shift_count = 0;

  while (error_location_register != error_pattern_register
         //) {
         && error_location_shift_count < 2 * (rho-1+1)) {
    error_location_register = shift(poly, n, error_location_register, 0);
debug("error_location_register %b error_pattern_register %b\n", error_location_register, error_pattern_register);
    error_location_shift_count++;
  }
  if (error_location_shift_count == rho-1+1) {
    debug("fatal: this should not happen(?)\n");
    return; //exit(1);
  }
  debug("error_location_shift_count %d\n", error_location_shift_count);
  debug("error_location_register %d\n", error_location_register);

  int a1, a2;

  get_a1_a2(&a1, &a2, l, rho);

  int lambda1 = error_pattern_shift_count;
  int lambda2 = error_location_shift_count;

  int q = a1 * (2 * l - 1) * lambda2 + a2 * rho * lambda1;
  debug("pre-q %d\n", q);
  q = q % 279;
  debug("q %d n-q %d\n", q, 279 - q);
}

static void test_remainder3(void)
{
  unsigned char data[2 + (265+7)/8];
  for (int i = 0; i < (265+7) / 8; i++) data[i+2] = i;
  int c = crc_bit(data + 2, 265, 0x4a25, 14, 0, 0);
  data[0] = c >> 8;
  data[1] = c & 255;
  fire_decode_book(data);
}

int main(void)
{
  int l = 6;
  int rho = 31;
  int a1;
  int a2;

  get_a1_a2(&a1, &a2, l, rho);

  debug("a1 %d a2 %d val %d\n", a1, a2, a1 * (2 * l - 1) + a2 * rho);

  test_crc();

  test_remainder();
  test_remainder2();
  debug("-----------------------------------\n");
  test_remainder3();

  return 0;
}

#endif /* MAIN */
